#!/usr/bin/env python
#Author: Mark Feineigle
#Create Date: 2018/02/06
#Last Modify: 2018/02/06
# Simple transposition cypher
# (2017)_Stallings_-_Cryptography_and_network_security_principles_and_practice.pdf
# page 107

from collections import defaultdict
import numpy as np
from random import choice

#pretty print verbose output
def pprint(inp, cols, rows, d, outp, mode):
  print
  print "Input  = {}".format(inp)
  print "Size   = cols: {} rows: {}".format(cols, rows)
  print "Dict   =",
  for i in key:
    print "{}={} /".format(i, d[int(i)]),
  print
  print "Output = {}".format(outp)

#Inputs
key = "961834" #numbers can not repeat
plain = "attackpostponeduntiltwoam"

def encode(key, plain, verbose=False):
  #calculate matrix size
  plainlen = float(len(plain))
  cols = len(key)
  rows = int(np.ceil(plainlen/cols))

  #pad the plaintext to fill the matrix
  padlen = int((plainlen/cols))
  while padlen < rows:
    plain += chr(choice(range(97, 123))) #pad with a random letter a-z
    padlen = int((float(len(plain))/cols)) #recalculate new length
  
  #convert plaintext into ciphertext via dict
  d = defaultdict(str)
  for i,p in enumerate(plain):
    d[int(key[i%len(key)])] += p
  cipher = "".join(d.values())

  if verbose: pprint(plain, cols, rows, d, cipher, "cipher")
  return cipher

def decode(key, cipher, verbose=False):
  #calculate matrix size
  cipherlen = float(len(cipher))
  cols = len(key)
  rows = int(np.ceil(cipherlen/cols))

  #build a new dict from ciphertext
  d = defaultdict(str)
  for i in range(cols):
    pos = i*rows
    d[int(sorted(key)[i])] = (cipher[pos:pos+rows])

  #cat the new dictionary into decoded msg
  decoded = ""
  for i in range(rows):
    for j in range(cols):
      decoded += d[int(key[j])][i]

  if verbose: pprint(cipher, cols, rows, d, decoded, "decoded")
  return decoded


if __name__ == "__main__":
  print "Key    = {}".format(key)
  cipher1 = encode(key, plain, True)
  cipher2 = encode(key, cipher1, True)
  print "\n"+"---DECODING"*7+"---"
  decode1 = decode(key, cipher2, True)
  decode2 = decode(key, decode1, True)
